# Welcome to the MSU D2L Instructor API

This repository has been created as a part of CMSE495: Experiential Learning in Data Science at Michigan Sate University. This course is the capstone for the data science major and provides the opportunity for students to work in teams on a sponsored project as a culmination of the skills they have learned. 

The sponsor for the D2L Instructor API project is Michigan State University. The goal of this project is to build a data cleaning API for the learning management system, Desire 2 Learn (D2L), to provide more intuitive, insightful, and accesible student performance data to researchers and instructors. Primarily this involves converting D2L's default format for quiz and survey data into a more useful, condensed form. 

## Group Members:
- Olivia Sheng Qiu <qiuolivi@msu.edu>

- Pranay Rahul Pentaparthy <pentapar@msu.edu>

- Erin Elizabeth Sawyer <sawyerer@msu.edu>

- Jonah Masaki Wehner <wehnerjo@msu.edu>

- Jiaye Xie <xiejiaye@msu.edu>

## Milestones and Project Information:

### Project Proposal
Here is a [link](https://mediaspace.msu.edu/media/MSUD2LInstructorAPI-CMSE495_Proposal_Presentation_Video/1_8nkuh5ul) to our proposal presentation video for more information about our project! 

### Closed Loops
Here is a [link](https://mediaspace.msu.edu/media/MSUD2LInstructorAPI-CMSE495_Closed-Loop_Presentation_Video/1_lirffq9v) to our closed loop presentation video for more information about our project! 

### Final Presentation
Here is a [link](https://mediaspace.msu.edu/media/MSUD2LInstructorAPI-CMSE495_Final_Project_Video/1_dy0poenh) to our final presentation video for more information about our project! 

## Navigate Our Repository

The 'Reports' directory contains helpful resources for using our product. The instructions for installing Conda on different systems like Windows and MacOS can be found in this folder. It also contains the UsageRequirementsLimitations.md file which gives information on usage requirements and usage limitations. The INSTALL.md file also has important instructions for using our software.

There are two different GUIs that can be used to interface with our software. The widget-based GUI can be accessed by navigating to src-> Widget-Based_GUI_WithLabelKeys.ipynb. The TKinter interface is contained in the 'TestGUI.py' file.

For an example of using the functions in our library, please see 'UsageExamples.ipynb' in our 'Examples' directory. 

For an example of creating figures using our library, please see 'Bar_Visualization.ipynb' in our 'Figures' Directory. 

For deidentified example data, please see the 'DataFiles' directory.

Go to the INSTALL.md for further instructions for the API.

## Tutorials

Click [this link](https://mediaspace.msu.edu/media/Getting+D2L+Data+Output+Tutorial/1_i9pbey6y) for a video tutorial about getting data from D2L. 

Click [this link](https://mediaspace.msu.edu/media/WidgetBasedGUI_Tutorial/1_2unbogi0) for a video tutorial about using the Widget-Based GUI.

Click [this link](https://mediaspace.msu.edu/media/TKinter+GUI+Tutorial/1_cq87zx8m) for a video tutorial =about using the TKinter GUI.